////////////////////////////////////////////////////////////////////////////////
//==============================================================================
// Config.cpp   - Compile with Borland C++ builder -
//==============================================================================
// modified     | ver.  |  by                  |         description
//--------------|-------|----------------------|--------------------------------
// june 08 2003 | 0.91  | Matthieu WEBER       | 2nd official beta release
//              |       |mweber_29200@yahoo.com| 
//==============================================================================
// Comments:
//
//  English translation of variable's names in progress...
//
////////////////////////////////////////////////////////////////////////////////

//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Config.h"
#include "principal.h"
#include <Registry.hpp>
#include <winsock2.h>

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma link "DefautJaugeMat"
#pragma resource "*.dfm"

TConfiguration *Configuration;

//---------------------------------------------------------------------------
// Constructor
__fastcall TConfiguration::TConfiguration(TComponent* Owner)
        : TForm(Owner)
{
}

//---------------------------------------------------------------------------
// OnShow event: Set buttons and check boxes according to the actual configuration
void __fastcall TConfiguration::FormShow(TObject *Sender)
  {
  // Prevent the main windows from hidding when configuration windows is on
  Princ->Timer2->Enabled = false;

  // load text from the ini file => language used (do nothing for french)
  Charge_int_txt();

  // ComboBox to select the kind of shading
  ComboBox4->Items->Clear();
  for (int i = 0; i < Princ->ImageList2-> Count; i++)
    ComboBox4->Items->Add(i);
  ComboBox4->ItemIndex = Princ->Type_Texture;
  ComboBox4Change(NULL);

  // Test gauge icon
  Princ->ImageList1->GetIcon(1, Jauge_test->Icone);

 // Radio group: color of the gauges (not used in shading mode)
  if (Princ->Texture)
    ctrl_colors->ItemIndex = 4;
  else
    {
    if (Princ->Uniforme)
      ctrl_colors->ItemIndex = 3;
    else
      ctrl_colors->ItemIndex = Princ->NbSeuils;
    }
  // Controls of the main window's behaviour
  ctrl_on_top->Checked = (Princ->FormStyle == fsStayOnTop);
  ctrl_autohide->Checked = Princ->bHideMainWindow;
  ctrl_hide_dir->ItemIndex = Princ->ZoneMasque;
  UpDownO1->Position = Princ->Timer2->Interval / 1000;

  // Controls for the kinds of drives and settings to monitor
  ctrl_memory->Checked = ((Princ->Affichage & DISPLAY_MEMORY) != 0);
  ctrl_batteries->Checked = ((Princ->Affichage & DISPLAY_BATTERY) != 0);
  ctrl_gauge_reverse->Checked = Princ->InvertDisp;
  ctrl_floppy->Checked = ((Princ->Affichage & DISPLAY_REMOVABLE_DRV) != 0);
  ctrl_cd->Checked = ((Princ->Affichage & DISPLAY_CDROM) != 0);
  ctrl_hdd->Checked = ((Princ->Affichage & DISPLAY_FIXED_DRV) !=  0);
  ctrl_network->Checked = ((Princ->Affichage & DISPLAY_NET_DRV) != 0);
  ctrl_ramdisk->Checked = ((Princ->Affichage & DISPLAY_RAMDISK) != 0);
  ctrl_main_vol->Checked = ((Princ->Affichage & DISPLAY_MAIN_VOL) != 0);
  ctrl_wav_vol->Checked = ((Princ->Affichage & DISPLAY_WAV_VOL) != 0);
  ctrl_midi_vol->Checked = ((Princ->Affichage & DISPLAY_MIDI_VOL) != 0);
  ctrl_cd_vol->Checked = ((Princ->Affichage & DISPLAY_CD_VOL) != 0);
  ctrl_aux_vol->Checked = ((Princ->Affichage & DISPLAY_AUX_VOL) != 0);
  ctrl_mic_vol->Checked = ((Princ->Affichage & DISPLAY_MIC_VOL) != 0);
  ctrl_status_bar->Checked = ((Princ->Affichage & DISPLAY_STATUS) != 0);

  // Thresholds colors
  ShapeS0->Brush->Color = Princ->Couleur[0];
  ShapeS1->Brush->Color = Princ->Couleur[1];
  ShapeS2->Brush->Color = Princ->Couleur[2];

  // Choose the action to perform when double click on a  drive
  ctrl_open_mode->ItemIndex = (int)Princ->Explorateur;
  ctrl_auto_launch->Checked = Princ->Autodemarrage;

  // Thresholds numeric settings
  // Caution to not swap theise 3 lines, otherwise the function
  // "DefinitionSeuil" wont be able to set the 3 thresholds
  UpDownS3->Position = Princ->ValSeuil[2];
  UpDownS2->Position = Princ->ValSeuil[1];
  UpDownS1->Position = Princ->ValSeuil[0];

  ShapeS3->Brush->Color = Princ->Couleur[3];
  ShapeUni->Brush->Color = Princ->Couleur[4];

  // Normal refresh
  if (Princ->Timer1->Interval > 3600000)
    {
    UpDown1->Position = Princ->Timer1->Interval / 3600000;
    ctrl_refresh_unit->ItemIndex = 2;
    }
  else
    {
    if (Princ->Timer1->Interval > 60000)
      {
      UpDown1->Position = Princ->Timer1->Interval / 60000;
      ctrl_refresh_unit->ItemIndex = 1;
      }
    else
      {
      UpDown1->Position = Princ->Timer1->Interval / 1000;
      ctrl_refresh_unit->ItemIndex = 0;
      }
    }

  /*
  // Dynamic refresh (not implemented yet)
  CheckBox1->Checked = ;
  UpDown2->Position = ;
  ComboBox2->ItemIndex = ;
  UpDown3->Position = ;
  ComboBox3->ItemIndex = ;
  */

  ctrl_colorsClick(Princ);
  ctrl_autohideClick(Princ);
  Edit1Combo1Change(Princ);
  ctrl_dynamic_refreshClick(Princ);
  }

//---------------------------------------------------------------------------
// OnClick event from the radio group: colors / thresholds
void __fastcall TConfiguration::ctrl_colorsClick(TObject *Sender)
  {
  ShapeS3->Visible = (ctrl_colors->ItemIndex == 0);
  ShapeS2->Visible = (ctrl_colors->ItemIndex < 2);
  ShapeS1->Visible = (ctrl_colors->ItemIndex < 3);
  ShapeS0->Visible = (ctrl_colors->ItemIndex < 3);
  ShapeUni->Visible = (ctrl_colors->ItemIndex == 3);
  ComboBox4->Enabled = (ctrl_colors->ItemIndex == 4);

  EditS1->Enabled = ShapeS1->Visible;
  EditS2->Enabled = ShapeS2->Visible;
  EditS3->Enabled = ShapeS3->Visible;

  UpDownS1->Enabled = ShapeS1->Visible;
  UpDownS2->Enabled = ShapeS2->Visible;
  UpDownS3->Enabled = ShapeS3->Visible;

  LabelPS1->Enabled = ShapeS1->Visible;
  LabelPS2->Enabled = ShapeS2->Visible;
  LabelPS3->Enabled = ShapeS3->Visible;
  TrackBar1Change(NULL);
  DefinitionSeuil(NULL);
  }

//---------------------------------------------------------------------------
// OnClick event for auto-hide feature
void __fastcall TConfiguration::ctrl_autohideClick(TObject *Sender)
  {
  ctrl_hide_dir->Enabled = ctrl_autohide->Checked;
  ctrl_after_n_sec->Enabled = ctrl_autohide->Checked;
  EditO1->Enabled = ctrl_autohide->Checked;
  UpDownO1->Enabled = ctrl_autohide->Checked;
  ctrl_sec->Enabled = ctrl_autohide->Checked;
  }

//---------------------------------------------------------------------------
// OnMouseDown event to select the color of the gauges in threshold mode
void __fastcall TConfiguration::ShapeMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
  {
  if (Button == mbLeft)
    {
    ColorDialog1->Color = ((TShape*) Sender)->Brush->Color;
    if(ColorDialog1->Execute())
      ((TShape*) Sender)->Brush->Color = ColorDialog1->Color;
    }
  }

//---------------------------------------------------------------------------
// OnChange event: set the refresh rate in normal condition
void __fastcall TConfiguration::Edit1Combo1Change(TObject *Sender)
  {
  ctrl_length->Caption = Edit1->Text + " " + ctrl_refresh_unit->Items->Strings[ctrl_refresh_unit->ItemIndex];
  }

//---------------------------------------------------------------------------
// OnChange event: set the refresh rate in dynamic refresh mode
void __fastcall TConfiguration::ctrl_dynamic_refreshClick(TObject *Sender)
  {
  ctrl_refresh_every1->Enabled = ctrl_dynamic_refresh->Checked;
  Edit2->Enabled = ctrl_dynamic_refresh->Checked;
  UpDown2->Enabled = ctrl_dynamic_refresh->Checked;
  ctrl_refresh_unit1->Enabled = ctrl_dynamic_refresh->Checked;
  ctrl_refresh_space_variation->Enabled = ctrl_dynamic_refresh->Checked;
  Edit3->Enabled = ctrl_dynamic_refresh->Checked;
  UpDown3->Enabled = ctrl_dynamic_refresh->Checked;
  ComboBox3->Enabled = ctrl_dynamic_refresh->Checked;
  ctrl_every->Enabled = ctrl_dynamic_refresh->Checked;
  ctrl_length->Enabled = ctrl_dynamic_refresh->Checked;
  }

//---------------------------------------------------------------------------

// OnClick event (Ok button) read controls values
void __fastcall TConfiguration::Validation(TObject *Sender)
  {
  // Radio group colors
  Princ->Texture = (ctrl_colors->ItemIndex == 4);
  Princ->Uniforme = (ctrl_colors->ItemIndex == 3);
  if (!Princ->Uniforme)
    {
    if (!Princ->Texture)
      Princ->NbSeuils = ctrl_colors->ItemIndex;
    }
  // Radio group options
  if (ctrl_on_top->Checked)
    Princ->FormStyle = fsStayOnTop;
  else
    Princ->FormStyle = fsNormal;
  Princ->bHideMainWindow = ctrl_autohide->Checked;
  if (Princ->bHideMainWindow)
    {
    Princ->ZoneMasque = ctrl_hide_dir->ItemIndex;
    Princ->Timer2->Interval  = UpDownO1->Position * 1000;
    }

  // Radio group display
  if (ctrl_memory->Checked)
    NouvAffichage = DISPLAY_MEMORY;
  else
    NouvAffichage = 0;
  if (ctrl_batteries->Checked)
    NouvAffichage = NouvAffichage + DISPLAY_BATTERY;

  Princ->InvertDisp = ctrl_gauge_reverse->Checked;

  if (ctrl_floppy->Checked)
    NouvAffichage = NouvAffichage + DISPLAY_REMOVABLE_DRV;
  if (ctrl_cd->Checked)
    NouvAffichage = NouvAffichage + DISPLAY_CDROM;
  if (ctrl_hdd->Checked)
    NouvAffichage = NouvAffichage + DISPLAY_FIXED_DRV;
  if (ctrl_network->Checked)
    NouvAffichage = NouvAffichage + DISPLAY_NET_DRV;
  if (ctrl_ramdisk->Checked)
    NouvAffichage = NouvAffichage + DISPLAY_RAMDISK;
  if (ctrl_main_vol->Checked)
    NouvAffichage = NouvAffichage + DISPLAY_MAIN_VOL;
  if (ctrl_wav_vol->Checked)
    NouvAffichage = NouvAffichage + DISPLAY_WAV_VOL;
  if (ctrl_midi_vol->Checked)
    NouvAffichage = NouvAffichage + DISPLAY_MIDI_VOL;
  if (ctrl_cd_vol->Checked)
    NouvAffichage = NouvAffichage + DISPLAY_CD_VOL;
  if (ctrl_aux_vol->Checked)
    NouvAffichage = NouvAffichage + DISPLAY_AUX_VOL;
  if (ctrl_mic_vol->Checked)
    NouvAffichage = NouvAffichage + DISPLAY_MIC_VOL;
  if (ctrl_status_bar->Checked)
    NouvAffichage = NouvAffichage + DISPLAY_STATUS;

  // If no drive selected, we choose a default drive 
  // to be displayed to prevent an empty window !!
  if ((NouvAffichage == 0) || (NouvAffichage == DISPLAY_STATUS))
       {
       NouvAffichage = NouvAffichage + DISPLAY_FIXED_DRV; // Hdd(s) are displayed by default
       }

  // Radio group thresholds
  Princ->Couleur[0] = ShapeS0->Brush->Color;
  Princ->ValSeuil[0] = UpDownS1->Position;
  Princ->Couleur[1] = ShapeS1->Brush->Color;
  Princ->ValSeuil[1] = UpDownS2->Position;
  Princ->Couleur[2] = ShapeS2->Brush->Color;
  Princ->ValSeuil[2] = UpDownS3->Position;
  Princ->Couleur[3] = ShapeS3->Brush->Color;
  Princ->Couleur[4] = ShapeUni->Brush->Color;

  // Choose of the action to perform when double click
  Princ->Explorateur = (ctrl_open_mode->ItemIndex == 1);
  Princ->Autodemarrage = ctrl_auto_launch->Checked;

  // Shading selection
  Princ->Type_Texture = ComboBox4->ItemIndex;
  
  // Normal refresh rate
  switch(ctrl_refresh_unit->ItemIndex)   // Refresh every...
    {                                      
    case 0:
        Princ->Timer1->Interval = UpDown1->Position * 1000; // n seconds
    break;
    case 1:
        Princ->Timer1->Interval = UpDown1->Position * 60000; // n minutes
    break;
    case 2:
        Princ->Timer1->Interval = UpDown1->Position * 3600000; // n hours
    break;
    }

  /*
  // Dynamic refresh rate (not implemented yet)
  CheckBox1->Checked = ;
  UpDown2->Position = ;
  ComboBox2->ItemIndex = ;
  UpDown3->Position = ;
  ComboBox3->ItemIndex = ;
  */

  ModalResult = mrOk;
  }

//---------------------------------------------------------------------------
void __fastcall TConfiguration::TrackBar1Change(TObject *Sender)
// OnChange Event TrackBar1Change form test gauge (Jauge_test)
{
Jauge_test->Position = (float)TrackBar1->Position / 2097152;
Jauge_test->Libre = Princ->ConvertTaille(TrackBar1->Position);
  int i;
  bool Trouve;

  if (ctrl_colors->ItemIndex == 4)
    Jauge_test->Texture = true;
  else
    {
    Jauge_test->Texture = false;
    switch (ctrl_colors->ItemIndex)
      {
      case 3:
        Jauge_test->CoulBarre = ShapeUni->Brush->Color;
        break;

      case 2:   // Test gauge 1 threshold
        if (Jauge_test->Position > EditS1->Text)
          Jauge_test->CoulBarre = ShapeS1->Brush->Color;
        else
          Jauge_test->CoulBarre = ShapeS0->Brush->Color;
        break;

      case 1: // Test gauge 2 thresholds
        if (Jauge_test->Position < EditS1->Text)
          Jauge_test->CoulBarre = ShapeS0->Brush->Color;
        else
          {
          if (Jauge_test->Position < EditS2->Text)
            Jauge_test->CoulBarre = ShapeS1->Brush->Color;
          else
            Jauge_test->CoulBarre = ShapeS2->Brush->Color;
          }
        break;
      case 0: // Test gauge 3 thresholds
        if (Jauge_test->Position < EditS1->Text)
          Jauge_test->CoulBarre = ShapeS0->Brush->Color;
        else
          {
          if (Jauge_test->Position < EditS2->Text)
            Jauge_test->CoulBarre = ShapeS1->Brush->Color;
          else
            {
            if (Jauge_test->Position < EditS3->Text)
              Jauge_test->CoulBarre = ShapeS2->Brush->Color;
            else
              Jauge_test->CoulBarre = ShapeS3->Brush->Color;
            }
          }
        break;
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TConfiguration::DefinitionSeuil(TObject *Sender)
// Function used to lock thresholds each others so a threshold cannot
// be higher than an other.
{
  TrackBar1Change(NULL);
  switch (ctrl_colors->ItemIndex)
    {
    case 0:
      if (atoi(EditS2->Text.c_str()) < atoi(EditS1->Text.c_str()))
        EditS1->Text = EditS2->Text;
      if (atoi(EditS3->Text.c_str()) < atoi(EditS2->Text.c_str()))
        EditS2->Text = EditS3->Text;
    break;
    case 1:
      if (atoi(EditS2->Text.c_str()) < atoi(EditS1->Text.c_str()))
        EditS1->Text = EditS2->Text;
    break;
    }
}
//---------------------------------------------------------------------------
void __fastcall TConfiguration::ComboBox4Change(TObject *Sender)
// OnChange event for shading selection combobox
{
  Graphics::TBitmap *temp = new Graphics::TBitmap();
  // Shading selection
  Princ->ImageList2->GetBitmap(ComboBox4->ItemIndex, temp);
  Jauge_test->Bitmap = temp;
}
//---------------------------------------------------------------------------

void __fastcall TConfiguration::FormCreate(TObject *Sender)
{
  TEdit* NumericComponent;

  // Title of the settings window
  Configuration->Caption = (AnsiString)TXT_VERSION \
  + " " + Princ->txt_configuration;

  // Force all numeric edit box to accept numbers but no chars
  for (int i = 0; i < Configuration->ComponentCount; i++)
    {
    NumericComponent = (TEdit*)Configuration->Components[i];
    
    // We found a TEdit component
    if (dynamic_cast<TEdit *>(Configuration->Components[i]) != NULL)
      {
      NumericComponent->Name;
      SetWindowLong(NumericComponent->Handle,GWL_STYLE,
                GetWindowLong(NumericComponent->Handle,GWL_STYLE)
                                            | ES_NUMBER );
      }
    }
}
//---------------------------------------------------------------------------

void __fastcall TConfiguration::ComboBox4DrawItem(TWinControl *Control,
      int Index, TRect &Rect, TOwnerDrawState State)
{
  // Fills shading selection comboBox with clWindow color to erase ugly marks
  TCanvas* canvas = ComboBox4->Canvas;
  canvas->Brush->Style=bsSolid;
  canvas->Brush->Color=clWindow;
  canvas->FillRect(Rect);

  // Draws shading bitmaps in the comboBox
  Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
  Princ->ImageList2->GetBitmap(Index, Bitmap);
  // Draw the bitmap
  canvas->Draw(Rect.Left, Rect.Top - 1 + ((Rect.Bottom - Rect.Top)/2), Bitmap);
}
//---------------------------------------------------------------------------

// This function do the same as a part of Charge_cfg() but only for the
// configuration panel. If the ini file containing international language
// is missing, we use original french values defined in the object inspector
// for the configuration panel.
void __fastcall TConfiguration::Charge_int_txt(void)
  {
TIniFile *ini;

ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );

// About text is displayed in whatever the language is
ctrl_about->Caption = (AnsiString)TXT_VERSION + (AnsiString)TXT_ABOUT;

// Display the IP adress for user info in the about box
WORD wVersionRequested;
WSADATA wsaData;
char name[255];
AnsiString ip;
PHOSTENT hostinfo;
wVersionRequested = MAKEWORD( 2, 0 );

if ( WSAStartup( wVersionRequested, &wsaData ) == 0 )
  {
  if( gethostname ( name, sizeof(name)) == 0)
    {
    ctrl_about->Caption = ctrl_about->Caption + "\n" + name;     // Computer's name
    if((hostinfo = gethostbyname(name)) != NULL)
      {
      ip = inet_ntoa (*(in_addr *)*hostinfo->h_addr_list);
      ctrl_about->Caption = ctrl_about->Caption + "   @ IP: " + ip;// IP address
      }
    }
  WSACleanup( );
  }

// Try to read a value on the ini file to see if it exists => if yes we change
// the language (we don't use default values here to save mem space!!)
if (strncmp("###", ini->ReadString("Language", "\"Settings\"", "###").c_str(), 3) == 0)
  {
  return;  // file dosen't exist or is invalid => keep french default values
  }

// Configuration title windows
Configuration->Caption = (AnsiString)TXT_VERSION + " " + ini->ReadString\
   ("Language", "\"Settings window title\"", "###");

// Main setting tab
ctrl_main_tab->Caption = ini->ReadString("Language", "\"Main\"", "###");
ctrl_open_mode->Caption = ini->ReadString("Language", "\"Double click Open\"", "###");
ctrl_open_mode->Items->Clear();
ctrl_open_mode->Items->Add(ini->ReadString("Language", "\"File manager\"", "###"));
ctrl_open_mode->Items->Add(ini->ReadString("Language", "\"Explorer\"", "###"));
ctrl_auto_launch->Caption = ini->ReadString("Language", "\"Launch at Windows startup\"", "###");

// Display tab
ctrl_display_tab->Caption = ini->ReadString("Language", "\"Display\"", "###");
ctrl_system->Caption = ini->ReadString("Language", "\"System\"", "###");
ctrl_gauge_reverse->Caption = ini->ReadString("Language", "\"Reverse display\"", "###");
ctrl_memory->Caption = ini->ReadString("Language", "\"Memory\"", "###");
ctrl_batteries->Caption = ini->ReadString("Language", "\"Batteries\"", "###");
ctrl_drives->Caption = ini->ReadString("Language", "\"Drives\"", "###");
ctrl_floppy->Caption = ini->ReadString("Language", "\"Floppy disks\"", "###");
ctrl_hdd->Caption = ini->ReadString("Language", "\"Hard disks\"", "###");
ctrl_cd->Caption = ini->ReadString("Language", "\"CDs /DVDs\"", "###");
ctrl_network->Caption = ini->ReadString("Language", "\"Mapped network drives\"", "###");
ctrl_ramdisk->Caption = ini->ReadString("Language", "\"Ramdisks\"", "###");
ctrl_audio->Caption = ini->ReadString("Language", "\"Audio\"", "###");
ctrl_main_vol->Caption = ini->ReadString("Language", "\"MAIN volume\"", "###");
ctrl_wav_vol->Caption = ini->ReadString("Language", "\"WAV volume\"", "###");
ctrl_midi_vol->Caption = ini->ReadString("Language", "\"MIDI volume\"", "###");
ctrl_cd_vol->Caption = ini->ReadString("Language", "\"CD volume\"", "###");
ctrl_mic_vol->Caption = ini->ReadString("Language", "\"Microphone input volume\"", "###");
ctrl_aux_vol->Caption = ini->ReadString("Language", "\"Auxiliary input volume\"", "###");

// Appearance tab
ctrl_appearance_tab->Caption = ini->ReadString("Language", "\"Look & feel\"", "###");
ctrl_colors->Caption = ini->ReadString("Language", "\"Colors\"", "###");
ctrl_colors->Items->Clear();
ctrl_colors->Items->Add(ini->ReadString("Language", "\"3 Thresholds\"", "###"));
ctrl_colors->Items->Add(ini->ReadString("Language", "\"2 Thresholds\"", "###"));
ctrl_colors->Items->Add(ini->ReadString("Language", "\"1 Threshold\"", "###"));
ctrl_colors->Items->Add(ini->ReadString("Language", "\"Uniform\"", "###"));
ctrl_colors->Items->Add(ini->ReadString("Language", "\"Shading\"", "###"));
ctrl_test->Caption = ini->ReadString("Language", "\"Test\"", "###");
ctrl_options->Caption = ini->ReadString("Language", "\"Options\"", "###");
ctrl_on_top->Caption = ini->ReadString("Language", "\"Stay on top\"", "###");
ctrl_autohide->Caption = ini->ReadString("Language", "\"Autohide\"", "###");
ctrl_hide_dir->Items->Clear();
ctrl_hide_dir->Items->Add(ini->ReadString("Language", "\"On right\"", "###"));
ctrl_hide_dir->Items->Add(ini->ReadString("Language", "\"On left\"", "###"));
ctrl_hide_dir->Items->Add(ini->ReadString("Language", "\"On top\"", "###"));
ctrl_hide_dir->Items->Add(ini->ReadString("Language", "\"On bottom\"", "###"));
ctrl_after_n_sec->Caption = ini->ReadString("Language", "\"after\"", "###");
ctrl_sec->Caption = ini->ReadString("Language", "\"Sec.\"", "###");
ctrl_status_bar->Caption = ini->ReadString("Language", "\"Status bar\"", "###");

// Refresh
ctrl_refresh_tab->Caption     = ini->ReadString("Language", "\"Refresh\"", "###");
ctrl_refresh_every->Caption   = ini->ReadString("Language", "\"Refresh every\"", "###");
ctrl_refresh_every1->Caption  = ctrl_refresh_every->Caption;
ctrl_refresh_unit->Items->Clear();
ctrl_refresh_unit->Items->Add(ini->ReadString("Language", "\"seconds\"", "###"));
ctrl_refresh_unit->Items->Add(ini->ReadString("Language", "\"minutes\"", "###"));
ctrl_refresh_unit->Items->Add(ini->ReadString("Language", "\"hours\"", "###"));
ctrl_refresh_unit1->Items->Clear();
ctrl_refresh_unit1->Items = ctrl_refresh_unit->Items;
ctrl_dynamic_refresh->Caption = ini->ReadString("Language", "\"Enable dynamic refresh rate\"", "###");
ctrl_refresh_space_variation->Caption = ini->ReadString("Language", "\"if free space on a drive change more than\"", "###");
ctrl_every->Caption  = ini->ReadString("Language", "\"every\"", "###");

// About tab
ctrl_about_tab->Caption  = ini->ReadString("Language", "\"About\"", "###");

// Buttons
ctrl_ok->Caption     = ini->ReadString("Language", "\"Ok\"", "###");
ctrl_cancel->Caption = ini->ReadString("Language", "\"Cancel\"", "###");

delete ini;
}




