////////////////////////////////////////////////////////////////////////////////
//==============================================================================
// Principal.h   - Compile with Borland C++ builder -
//==============================================================================
// modified     | ver.  |  by                  |         description
//--------------|-------|----------------------|--------------------------------
// june 08 2003 | 0.91  | Matthieu WEBER       | 2nd official beta release
//              |       |mweber_29200@yahoo.com| 
//==============================================================================
// Comments:
//
//  English translation of variable's names in progress...
//
////////////////////////////////////////////////////////////////////////////////

//---------------------------------------------------------------------------

#ifndef PrincipalH
#define PrincipalH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Graphics.hpp>
#include <ImgList.hpp>
#include "DefautJaugeMat.h"
#include <ComCtrls.hpp>
#include <Buttons.hpp>

/***************************************************************************/
/* Constants definitions                                                   */
/***************************************************************************/
// Optic discs capacity in bytes
#define MAX_DVD    8589934592      // Maximun presumed size of a DVD
#define MAX_CD_700  734003200      // Maximun presumed size of a 655 Mb CD
#define MAX_CD_655  686817280      // Maximun presumed size of a 700 Mb CD

#define MAX_THRESHOLDS 3            // Maximum thresholds for color gauges

#define TXT_ABOUT "\n\nGeneral Public Licence\n\nCopyright Matthieu\
 WEBER, 2003\n\nMail: mweber_29200@yahoo.fr\n"

#define TXT_VERSION "DSpace V. 0.91"

// Definition of the display variable
#define DISPLAY_MEMORY          1           // Display memory
#define DISPLAY_BATTERY         2           // Display battery supply
#define DISPLAY_REMOVABLE_DRV   4           // Display amovible drives
#define DISPLAY_FIXED_DRV       8           // Display HDDS...
#define DISPLAY_NET_DRV        16           // Display (mapped) network drives
#define DISPLAY_CDROM          32           // Display CD-ROM / DVD drives
#define DISPLAY_RAMDISK        64           // Display virtual RAM drives
#define DISPLAY_MAIN_VOL      128           // Display main volume ctrl
#define DISPLAY_WAV_VOL       256           // Display WAV volume ctrl
#define DISPLAY_MIDI_VOL      512           // Display MIDI volume ctrl
#define DISPLAY_CD_VOL       1024           // Display CD volume ctrl
#define DISPLAY_AUX_VOL      2048           // Display auxiliary volume ctrl
#define DISPLAY_MIC_VOL      4096           // Display microphone volume ctrl
#define DISPLAY_STATUS       8192           // Display status bar

// Zones where the main window can be hidden
#define HIDE_RIGHT  0
#define HIDE_LEFT   1
#define HIDE_TOP    2
#define HIDE_BOTTOM 3

// Size of controls and gauges, in pixels
#define TAILLE_JAUGE_LARG 120 // May alter main window's width
#define TAILLE_JAUGE_HAUT 32  // May alter main window's height
#define TAILLE_VOLUME 15      // Height of a sound volume control

// Specify tags used to retrive the kind of drive tanks to hits icon
#define TAG_CD 4                  // For a CD / DVD drive


// Register key's definitions + Default values
#define DEF_ON_TOP fsNormal	  // boolean allways visible set to false by default
#define DEF_DISPLAY_CTRLS (DISPLAY_MEMORY | DISPLAY_REMOVABLE_DRV | DISPLAY_FIXED_DRV \
     | DISPLAY_NET_DRV | DISPLAY_CDROM)// Drives and controls to display
#define DEF_SHADING_ON           true  // Displaying shading in gauges
#define DEF_NO_THRESHOLDS        false  // Display gauges with one color for full range
#define DEF_NB_THRESHOLDS            0  // Number of thresholds currently used
#define DEF_COLOR0              clRed  // Color below the low threshold
#define DEF_THRESHOLD0              20  // Low threshold
#define DEF_COLOR1           clYellow  // Color below the medium threshold
#define DEF_THRESHOLD1              50  // Medium threshold
#define DEF_COLOR2             clLime  // Color below the high threshold
#define DEF_THRESHOLD2              80  // High threshold
#define DEF_COLOR3             clBlue  // Color above the high threshold
#define DEF_COLOR4             clBlue  // Color used when no threshold wanted 
#define DEF_SHADING_TYPE            0  // Shadig texture ID
#define DEF_NORMAL_REFRESH_RATE 15000  // Normal refresh rate, in ms
#define DEF_AUTO_HIDE           false  // True if the autohide feature is enabled
#define DEF_VISIBILITY_TIME      5000  // Time before hidding the main windows in ms
#define DEF_HIDDING_ZONE   HIDE_RIGHT  // Zone where th windows is hidden
#define DEF_EXPLORER_BROWSER        0  // Browse with explorer or directory browser
#define DEF_AUTO_LAUNCH             1  // If true start at Windows startup

// ##Default text messages##
// Error messages (french value)
#define DEF_INI_VAL_TXT_DRIVE_TYPE_UNKNOWN "Impossible de dterminer le type du lecteur"

// Labels for drives and controls (french default values)
#define DEF_INI_VAL_TXT_BATTERY "Battrie"                      // Battery status
#define DEF_INI_VAL_TXT_MEMORY "Mmoire vive"                  // Memory
#define DEF_INI_VAL_TXT_NEED_REFRESH "Db click > maj"          // Request user refresh
#define DEF_INI_VAL_TXT_NO_DISK "- Lecteur vide -"             // No disk in drive
#define DEF_INI_VAL_TXT_NO_BATTERY "- Pas de batterie -"       // No battery
#define DEF_INI_VAL_TXT_BATTERY_POWERED "Sur Battrie..."       // Battery powered
#define DEF_INI_VAL_TXT_LOW_BATTERY "Battrie faible"           // Low battery
#define DEF_INI_VAL_TXT_BATTERY_CRITICAL "Battrie critique !"  // Low battery critical
#define DEF_INI_VAL_TXT_BATTERY_CHARGING "Battrie en charge"   // Battery charging
#define DEF_INI_VAL_TXT_BATTERY_STAT_ERROR "- Err. status batt ! -" // Battery status error

// Status bar french default messages:
// Audio french texts (default values)
#define DEF_INI_VAL_TXT_MAIN_VOL "Vol. gnral :"  // Main volume
#define DEF_INI_VAL_TXT_MIDI_VOL "Volume MIDI :"   // MIDI volume
#define DEF_INI_VAL_TXT_AUX_VOL "Volume aux. :"    // Auxiliary input volume 
#define DEF_INI_VAL_TXT_MIC_VOL "Volume mic. :"    // Microphone input volume
#define DEF_INI_VAL_TXT_WAV_VOL "Volume WAV : "    // WAV volume
#define DEF_INI_VAL_TXT_CD_VOL "Volume CD :"       // CD player volume

// Warning messages in status bar:
#define DEF_INI_VAL_TXT_MEM_2_PERCENT "Mem. "       // If memory < = to 2 %
#define DEF_INI_VAL_TXT_BATT_2_PERCENT "BATT."      // If battery level < = to 2 %
#define DEF_INI_VAL_TXT_SUFFIX_2_PERCENT "< 2%"     // Suffix added to the warning message


// Name of the system registery key
#define REG_CLE_APP           "\\Software\\Weber_Matthieu\\DSpace"
#define REG_VAL_ON_TOP        "Allways visible"
#define REG_VAL_LEFT          "Left"
#define REG_VAL_TOP           "Top"
#define REG_VAL_DISPLAY_CTRLS "Display drives"
#define REG_VAL_TEXTURE       "Shading enabled"
#define REG_UNIFORME          "One color only"
#define REG_VAL_NSEUILS       "Nb of thresholds"
#define REG_VAL_COUL0         "Color 0"
#define REG_VAL_SEUIL0        "Threshold 0"
#define REG_VAL_COUL1         "Color 1"   // For comments: see above.
#define REG_VAL_SEUIL1        "Threshold 1"
#define REG_VAL_COUL2         "Color 2"
#define REG_VAL_SEUIL2        "Threshold 2"
#define REG_VAL_COUL3         "Color 3"
#define REG_VAL_COUL4         "Color 4"
#define REG_VAL_TYPE_TEXTURE  "Type of shading"
#define REG_VAL_MAJNORM       "Normal refresh"
#define REG_VAL_MASQUER       "AutoHide main window feature enabled"
#define REG_VAL_DURVIS        "Visiblity time"
#define REG_VAL_ZONMASQ       "Hidding zone"
#define REG_VAL_EXPLORATEUR   "Explorer"
#define REG_VAL_AUTODEMARRAGE "Auto launch"

/***************************************************************************/
/* Components definition                                                   */
/***************************************************************************/

class PACKAGE TJaugeMat : public TDefautJaugeMat
{
public:
    char Lecteur;
    char Chemin[4];

    __fastcall TJaugeMat(TComponent* Owner);
};

//---------------------------------------------------------------------------
class TPrinc : public TForm
{
__published:
  TTimer *Timer1;
  TImageList *ImageList1;
  TTimer *Timer2;
  TImageList *ImageList2;
  TTimer *StatusBarTimer;


    void __fastcall Timer1Timer(TObject *Sender);
    void __fastcall FormDblClick(TObject *Sender);
    void __fastcall FormDestroy(TObject *Sender);
    void __fastcall Timer2Timer(TObject *Sender);
    void __fastcall FormMouseMove(TObject *Sender, TShiftState Shift, int X,
            int Y);
    void __fastcall OnMouseDown(TObject *Sender,
    TMouseButton Button, TShiftState Shift, int X, int Y);
    void __fastcall FormOnChange (TObject *Sender);
    AnsiString __fastcall ConvertTaille(__int64 Taille);
    AnsiString __fastcall ConvertHeure(__int64 Secondes);

    void __fastcall Timer1s(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);

private:

    TList *GaugeList;              // Drives / Memory / Battery /CPU... Gauges list
    TList *SoundCtrlList;          // Audio controls lists
    TJaugeMat *Gauge;              // Gauge component
    TTrackBar *Volume;             // Volume potentiometer
    TBevel *VolCtrlBevel;          // Bevel for volume control
    TLabel *VolTxt;                // Volume control label
    TSpeedButton *SelectAudio;     // Mute button
    TStatusBar *StatusBar;         // Status bar
    unsigned int MainWindowHeight; // Calculated height of the main window

    void __fastcall DisplaysControls();
    void __fastcall AddGauge(char NomLect, unsigned char IndiceIco);
    void __fastcall AddSoundControl(char* controle, unsigned char index);
    void __fastcall CleanUp();
    void __fastcall GetIcons();
    void __fastcall UpdateMemory(TJaugeMat *Gauge);
    void __fastcall UpdateBattery(TJaugeMat *Gauge);
    void __fastcall UpdateDrive(TJaugeMat *Gauge);
    void __fastcall UnHide(bool Remasquer);
    void __fastcall Load_cfg(void);
    void __fastcall Save_cfg(void);

public:
    unsigned int Affichage;
    bool InvertDisp;
    bool Texture;
    bool Uniforme;
    unsigned int  Type_Texture;
    unsigned char NbSeuils;
    unsigned char ValSeuil[MAX_THRESHOLDS];
    TColor Couleur[MAX_THRESHOLDS + 2];
    bool bHideMainWindow;
    unsigned char ZoneMasque;
    bool Explorateur;
    bool Autodemarrage;

    // Multi language support displayed texts in labels/warning messages
    AnsiString txt_unknown_drive_type;
    AnsiString txt_configuration;
    AnsiString txt_batteries;
    AnsiString txt_memoire;
    AnsiString txt_rafraich;
    AnsiString txt_lect_vide;
    AnsiString txt_batt_non;
    AnsiString txt_batt_debit;
    AnsiString txt_batt_faible;
    AnsiString txt_batt_critique;
    AnsiString txt_batt_charge;
    AnsiString txt_batt_erreur;
    AnsiString txt_volume;
    AnsiString txt_vol_midi;
    AnsiString txt_vol_aux;
    AnsiString txt_vol_micro;
    AnsiString txt_vol_wav;
    AnsiString txt_vol_cd;
    AnsiString txt_mem_2_pourcent;
    AnsiString txt_batt_2_pourcent;
    AnsiString txt_suffixe_2_pourcent;

    __fastcall TPrinc(TComponent* Owner);
};

//---------------------------------------------------------------------------
extern PACKAGE TPrinc *Princ;
//---------------------------------------------------------------------------
#endif
 